#include "alloc.h"
#include "debug.h"
#include "drivers.h"
#include "gdt.h"
#include "idt.h"
#include "kprintf.h"
#include "memory.h"
#include "multiboot.h"
#include "power.h"
#include "shell.h"
#include "string.h"
#include "terminal.h"

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

/* Check if the compiler thinks you are targeting the wrong operating system. */
#if defined(__linux__)
#error                                                                         \
    "You are not using a cross-compiler, you will most certainly run into trouble"
#endif

/* This tutorial will only work for the 32-bit ix86 targets. */
#if !defined(__i386__)
#error "This tutorial needs to be compiled with a ix86-elf compiler"
#endif

/* Par contre je me dois d'être honnête avec toi, j'ai passé un très bon moment
 * hier soir c'était vraiment posé et tout mais j'ai pas trop ressenti de
 * feeling qui me donnerait envie de continuer dans une relation "couple" sur le
 * long terme. Je sais pas trop comment le dire sans que ça te blesse, c'est pas
 * personnel ou quoi c'est cool quand on parle et tout mais juste je ne pense
 * pas pouvoir faire marcher une relation comme celle là :( */
/* Voilà je voulais juste te le dire pour pas que tu te mettes quelque chose en
 * tête qui n'arrivera pas, je trouve ça plus correct */

static void set_mem_size(multiboot_info_t *mbd, uint32_t magic)
{
	/* Make sure the magic number matches for memory mapping */
	if (magic != MULTIBOOT_BOOTLOADER_MAGIC)
		kpanic("invalid magic number!");

	/* Check bit 6 to see if we have a valid memory map */
	if (!(mbd->flags >> 6 & 0x1))
		kpanic("invalid memory map given by GRUB bootloader");

	/* Loop through the memory map and display the values */
	for (uint32_t i = 0; i < mbd->mmap_length;
	     i += sizeof(multiboot_memory_map_t)) {
		multiboot_memory_map_t *mmmt =
		    (multiboot_memory_map_t *)(mbd->mmap_addr + i);
		/* if (mmmt->type == MULTIBOOT_MEMORY_AVAILABLE) */
		/* mem_size += mmmt->len; */
	}
}

extern uint32_t boot_page_table1;

void get_kernel_page_used(void)
{
	uint32_t *boot_pt = &boot_page_table1;
	size_t i = 0;
	size_t used_pages = 0;
	for (; i < 1024; i++) {
		if ((boot_pt[i] != 0) && (boot_pt[i] != (i << 12))) {
			used_pages++;
		}
	}
	kprintf("page used: %d/%d\n", used_pages, PT_SIZE);
}

void kernel_main(multiboot_info_t *mbd, uint32_t magic)
{
	terminal_initialize();
	init_gdt();
	init_idt();
	init_memory(mbd, magic);
	load_drivers();
	kprintf(KERN_ALERT
	        "I see no way to confuse an array of 256 seg:off pairs with a "
	        "complex 8*unknown quantity -byte descriptor table. -- Troy "
	        "Martin 03:50, 22 March 2009 (UTC)\n");
	// PRINT_PTR(alloc_frame());
	if (false) {
		void *start = alloc_pages(1);
		int *ptr;
		uint32_t i;
		for (i = 1; (ptr = alloc_pages(PAGE_SIZE)); i++) {
			memset(ptr, i % 256, PAGE_SIZE);
			*ptr = i;
			if (i == 4096 && 0)
				break;
		}
		PRINT_UINT(i); // 32573
		for (uint32_t j = 1; j < i - 1; j++) {
			ptr = start + j * PAGE_SIZE;
			for (uint32_t k = sizeof(*ptr);
			     k < PAGE_SIZE - sizeof(*ptr); k++)
				if (((uint8_t *)ptr)[k] != (j % 256))
					kprintf("cringe %u != %u\n",
					        ((uint8_t *)ptr)[k], j % 256);
		}

	} else {
		while (vmalloc(10))
			;
	}
	/* vmalloc(10); */
	shell_init();
}
